import java.io.File;
import java.io.FileInputStream;
import java.util.Hashtable;

import org.apache.poi.ss.formula.functions.FreeRefFunction;
import org.apache.poi.ss.formula.udf.AggregatingUDFFinder;
import org.apache.poi.ss.formula.udf.DefaultUDFFinder;
import org.apache.poi.ss.formula.udf.UDFFinder;
import org.apache.poi.ss.usermodel.FormulaEvaluator;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.usermodel.WorkbookFactory;
import org.apache.poi.ss.util.CellAddress;

import epm.office.model.HsGetValue;

public class HsGetValTest {
    public static void main( String[] args ) {
        
    	String fileName = "HsGetVal.xlsx";
        
        File workbookFile = new File( fileName ) ;
        
        try {
            FileInputStream fis = new FileInputStream(workbookFile);
            Workbook workbook = WorkbookFactory.create(fis);
            
            Sheet sheet = workbook.getSheetAt(workbook.getActiveSheetIndex());
            System.out.println("cell_4_1 formula:" + sheet.getRow(4).getCell(1).getCellFormula());
            System.out.println("cell_4_2 formula:" + sheet.getRow(4).getCell(2).getCellFormula());
            
            // hard code HsGetValue test values for formulas on the sheet
            Hashtable<CellAddress, String> cellToValueTable = new Hashtable<CellAddress, String>();
            CellAddress cell4_1 = new CellAddress(4, 1);
            cellToValueTable.put(cell4_1, "678.0");
            CellAddress cell4_2 = new CellAddress(4, 2);
            cellToValueTable.put(cell4_2, "123.0");

            String[] functionNames = { HsGetValue.name } ;
            FreeRefFunction[] functionImpls = { new HsGetValue(cellToValueTable) } ;
            UDFFinder udfs = new DefaultUDFFinder( functionNames, functionImpls ) ;
            UDFFinder udfToolpack = new AggregatingUDFFinder( udfs ) ;	                      
            workbook.addToolPack(udfToolpack);            
            
            FormulaEvaluator formulaEvaluator = workbook.getCreationHelper().createFormulaEvaluator();
            formulaEvaluator.setIgnoreMissingWorkbooks(true);
            formulaEvaluator.evaluateAll();            
            
        } catch( Exception e) {
        	e.printStackTrace();
        }
    }
}