import java.util.Hashtable;

import org.apache.poi.ss.formula.OperationEvaluationContext;
import org.apache.poi.ss.formula.eval.NumberEval;
import org.apache.poi.ss.formula.eval.ValueEval;
import org.apache.poi.ss.formula.functions.FreeRefFunction;
import org.apache.poi.ss.util.CellAddress;

public class HsGetValue implements FreeRefFunction {
	public static final String name = "HsGetValue";
	
	private Hashtable<CellAddress, String> cellValues;

	public HsGetValue(Hashtable<CellAddress, String> cellValues) {
		super();
		this.cellValues = cellValues;
	}

	@Override
	public ValueEval evaluate(ValueEval[] args, OperationEvaluationContext evaluationContext) {
		int row = evaluationContext.getRowIndex();
		int column = evaluationContext.getColumnIndex();		
		CellAddress cell = new CellAddress(row, column);
		
		String value = cellValues.get(cell);
		return new NumberEval( Double.parseDouble(value) );
	}

}